#%%

class Node:
    def __init__(self, data=None) -> None:
        self.data = data
        self.parent = None
        self.left = None
        self.right = None

    def __str__(self) -> str:
        return F"{self.data}"

    def insert_left(self, data=None):
        tree.left = Node(data)
        tree.left.parent = self
        return tree.left

    def insert_right(self, data=None):
        tree.right = Node(data)
        tree.right.parent = self
        return tree.right
    
    def print_as_tree(self, level=0):
        spaces = " " * (level * 3 - 2)
        prefix = spaces + "└──" if level != 0 else ""
        print(F"{prefix} {self}")
        
        children = []
        children.append(self.left if self.left else None)
        children.append(self.right if self.right else None)
    
        for child in children:
            if child:
                child.print_as_tree(level+1)

    def as_expr(self):
        result = ""
        if self:
            if self.left:
                result += ('(' + self.left.as_expr())
            result += str(self.data)
            if self.right:
                result += (self.right.as_expr() + ')')
        return result

#%%
# Fully parenthesized expressions in infix notation can also be computed using a tree

import operator

#expr = "((3 * (4 + 5)) + 6)"
expr = "((5 + 3) * (5 + 1))"
ops = {
       '+': operator.add,
       '-': operator.sub,
       '*': operator.mul
      }

tree = Node()
root = tree

# Iterate through expression and build tree:
pass
# Done

root.print_as_tree()

# %%

def evaluate(tree: Node) -> int:
    """
    Evaluate the expression tree recursively.
    If both children are set then the current node is an operator. Otherwise it is an operand.
    """
    pass

result = evaluate(root)
print(result)

#%%

print(root.as_expr())